using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using Outlook = Microsoft.Office.Interop.Outlook;
using System.Windows.Forms;

namespace OlCustomSendButtonExample
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("E048F219-D533-42F8-A4AA-0CEF8821A8BD"), ProgId("OlCustomSendButtonExample.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            InitializeComponent();
        }

        private AddinExpress.MSO.ADXOlInspectorCommandBar adxOlInspectorCommandBar1;
        private AddinExpress.MSO.ADXCommandBarButton adxCommandBarButton1;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxOlInspectorCommandBar1 = new AddinExpress.MSO.ADXOlInspectorCommandBar(this.components);
            this.adxCommandBarButton1 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            // 
            // adxOlInspectorCommandBar1
            // 
            this.adxOlInspectorCommandBar1.CommandBarName = "My Send Toolbar";
            this.adxOlInspectorCommandBar1.CommandBarTag = "d1e5332d-bbc2-415a-90d3-c19eea212c91";
            this.adxOlInspectorCommandBar1.Controls.Add(this.adxCommandBarButton1);
            this.adxOlInspectorCommandBar1.Position = AddinExpress.MSO.ADXMsoBarPosition.adxMsoBarTop;
            this.adxOlInspectorCommandBar1.Temporary = true;
            this.adxOlInspectorCommandBar1.UpdateCounter = 5;
            // 
            // adxCommandBarButton1
            // 
            this.adxCommandBarButton1.Caption = "My Send Button";
            this.adxCommandBarButton1.ControlTag = "e687752c-620c-45b0-aef4-adb0dbbe17c7";
            this.adxCommandBarButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCommandBarButton1.Temporary = true;
            this.adxCommandBarButton1.UpdateCounter = 3;
            this.adxCommandBarButton1.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.adxCommandBarButton1_Click);
            // 
            // AddinModule
            // 
            this.AddinName = "OlCustomSendButtonExample";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;
            this.AddinBeginShutdown += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinBeginShutdown);
            this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);

        }
        #endregion
 
        #region ADX automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        private const int WM_USER = 0x0400;
        private const int WM_MYMESSAGES = WM_USER + 1000;
        private static OutlookListener listener;
        private string entryID = String.Empty;

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        [DllImport("user32.dll")]
        public static extern IntPtr PostMessage(IntPtr hwnd, uint wMsg, Int32 wParam, Int32 lParam);

        private void adxCommandBarButton1_Click(object sender)
        {
            PostMessage(listener.Handle, WM_MYMESSAGES, 0, 0);
        }

        private void SendMail()
        {
            object currentItem = null;
            Outlook._MailItem mail = null;
            Outlook._Inspector inspector = null;

            try
            {
                inspector = OutlookApp.ActiveInspector();
                currentItem = inspector.CurrentItem;
                if (currentItem is Outlook.MailItem)
                {
                    mail = currentItem as Outlook.MailItem;
                    mail.Subject = "New subject";
                    mail.Body = "New Body";
                    mail.Send();
                }
            }
            finally
            {
                if (currentItem != null)
                    Marshal.ReleaseComObject(currentItem);
                if (inspector != null)
                    Marshal.ReleaseComObject(inspector);
            }
        }

        private class OutlookListener : NativeWindow, IDisposable
        {
            private bool disposed = false;
            private AddinModule parent;

            public OutlookListener(AddinModule parent)
            {
                this.parent = parent;
                CreateParams Params = new CreateParams();
                Params.Caption = parent.AddinName;
                this.CreateHandle(Params);
            }

            public void Dispose()
            {
                Dispose(true);
                GC.SuppressFinalize(this);
            }

            private void Dispose(bool disposing)
            {
                if (!this.disposed)
                {
                    if (!this.Handle.Equals(IntPtr.Zero))
                    {
                        this.ReleaseHandle();
                    }
                }
                disposed = true;
            }

            ~OutlookListener()
            {
                Dispose(false);
            }

            private static bool CompareStrings(string str1, string str2)
            {
                if (String.Compare(str1, str2, true, System.Globalization.CultureInfo.InvariantCulture) == 0)
                    return true;
                return false;
            }

            [System.Security.Permissions.PermissionSet(
                     System.Security.Permissions.SecurityAction.Demand,
                     Name = "FullTrust")]
            protected override void WndProc(ref Message m)
            {
                try
                {
                    switch (m.Msg)
                    {
                        case WM_MYMESSAGES:
                            lock (this)
                            {
                                try
                                {
                                    parent.SendMail();
                                }
                                catch
                                {
                                }
                            }
                            break;
                    }
                }
                finally
                {
                    base.WndProc(ref m);
                }
            }
        }

        private void AddinModule_AddinStartupComplete(object sender, EventArgs e)
        {
            listener = new OutlookListener(this);
        }

        private void AddinModule_AddinBeginShutdown(object sender, EventArgs e)
        {
            listener.Dispose();
        }
    }
}

